-----------------------------------------
-- Addon: Relational DKP
-- By: Shazear 
-- Shizukana <Veterans of the Phoenix>, Malygos
-- e-mail: shazear@hotmail.com
-- Code also used from CTRT
-- References: 
-----------------------------------------

-----------------------------------------
-- String Table

RDKP_SZ = {};
-- TODO: Investigate GlobalStrings.lua files for localized versions of the strings I need.
RDKP_SZ = {
	["enUS"] = {
		["HEADER"] = "Relational DKP System UI " .. RDKP_FULL_VERSION,
--		["SETTINGS"] = "Relational DKP Settings",
		["PATTERN_DEATH1"] = "(.+) dies.",
		["PATTERN_DEATH2"] = "You have slain (.+)!",
		["PATTERN_LOOT"] = "|c(.-)|Hitem:(.-)|h%[(.-)%]|h|r",
		["PATTERN_LOOT1"] = "([^%s]+) receives loot: (.+)%.",
		["PATTERN_LOOT2"] = "You receive loot: (.+)%.",
		["DATA_RESET"] = "Non Raid Transaction data being wiped, reset to system defaults, and repopulated as best as possible.",
		["RESTORE_DEFAULTS"] = "Restoring defaults.",
		["NO_KILL_AWARD"] = " not in Zone or Not Online or AFK and did not earn DKP for the kill.", -- Lead by Player Name.
		["NO_TIME_AWARD"] = " not in Zone or Not Online or AFK and did not earn DKP for time spent.", -- Lead by Player Name.
		["RAID_START"] = "Starting Raid...\nPlease click 'EndRaid' when the raid is finished.\nHowever, raid tracking/DKP will be closed if you reload your ui, so the raid will have to be restarted.\n However, if you leave the group, and there's a new Raid Leader, if he has this AddOn, then he should be able to resume DKP & Gear Awards.",
		["RAID_END"] = "Ending Raid...",
		["START_RAID"] = "Start Recording",
		["END_RAID"] = "End Recording",
		["SET_MAIN"] = "The current character is now the main for any others for this player.",
		["HIDE_CHAR"] = "Hide Char",
		["SHOW_CHAR"] = "Show Char",
	},
	-- TODO: Update w/ real translations.  Presently just using Babblefish.
	["deDE"] = {
		["HEADER"] = "Relational DKP System UI " .. RDKP_FULL_VERSION,
		["PATTERN_DEATH1"] = "(.+) dies.",
		["PATTERN_DEATH2"] = "You have slain (.+)!",
		["PATTERN_LOOT"] = "|c(.-)|Hitem:(.-)|h%[(.-)%]|h|r",
		["PATTERN_LOOT1"] = "([^%s]+) receives loot: (.+)%.",
		["PATTERN_LOOT2"] = "You receive loot: (.+)%.",
		["DATA_RESET"] = "Nicht repopulated die berfall-Verhandlungdaten, die abgewischt wurden, das Zurckstellen zu den System Rckstellungen und so gut wie mglich",
		["RESTORE_DEFAULTS"] = "Die Wiederherstellung fllt zurck",
		["NO_KILL_AWARD"] = " nicht in der Zone oder nicht online oder in AFK und erwarb nicht DKP fr die Ttung.", -- Lead by Player Name.
		["NO_TIME_AWARD"] = " nicht in der Zone oder nicht online oder in AFK und erwarb nicht DKP fr die verbrachte Zeit.", -- Lead by Player Name.
		["RAID_START"] = "berfall Beginnen...\nBitte Klicken ' Ende berfall ', wenn der berfall beendet wird.\nJedoch ist die berfallspurhaltung geschlossen, wenn Sie Ihre Benutzerschnittstelle neu laden, also mu der berfall wiederbegonnen werden.\n Jedoch wenn Sie die Gruppe lassen, und es gibt einen neuen berfall-Fhrer, wenn er dieses AddOn hat, dann er sollte in der LageSEIN, DKP u. Zahnrad-Preise wieder aufzunehmen.",
		["RAID_END"] = "Ende berfall...",
		["START_RAID"] = "berfall Beginnen",
		["END_RAID"] = "Ende berfall",
		["SET_MAIN"] = "Der gegenwrtige Buchstabe ist jetzt die Hauptleitung fr alle mgliche andere fr diesen Spieler.",
		["HIDE_CHAR"] = "Fell-Buchstabe",
		["SHOW_CHAR"] = "Zeigen Sie Buchstaben",
	},
	-- TODO: Update w/ real translations.  Presently just using Babblefish.
	["frFR"] = {
		["HEADER"] = "Relational DKP System UI " .. RDKP_FULL_VERSION,
		["PATTERN_DEATH1"] = "(.+) dies.",
		["PATTERN_DEATH2"] = "You have slain (.+)!",
		["PATTERN_LOOT"] = "|c(.-)|Hitem:(.-)|h%[(.-)%]|h|r",
		["PATTERN_LOOT1"] = "([^%s]+) receives loot: (.+)%.",
		["PATTERN_LOOT2"] = "You receive loot: (.+)%.",
		["DATA_RESET"] = "Non les donnes de transaction d'incursion tant essuyes, la remise aux dfauts de systme, et repopulated aussi bien que possible",
		["RESTORE_DEFAULTS"] = "L'reconstitution se transfre",
		["NO_KILL_AWARD"] = " pas dans la zone ou pas en ligne ou l'AFK et n'a pas gagn DKP pour la mise  mort.", -- Lead by Player Name.
		["NO_TIME_AWARD"] = " pas dans la zone ou pas en ligne ou l'AFK et n'a pas gagn DKP pendant le temps pass.", -- Lead by Player Name.
		["RAID_START"] = "Commenant L'Incursion...\nSvp clic 'incursion de fin 'quand l'incursion est finie.\nCependant, le cheminement d'incursion sera ferm si vous rechargez votre interface utilisateur, ainsi l'incursion devra tre remise en marche.\n Cependant, si vous laissez le groupe, et il y a un nouveau chef d'incursion, s'il a cet AddOn, alors il devrait pouvoir reprendre DKP et rcompenses de vitesse.",
		["RAID_END"] = "Finissant L'Incursion...",
		["START_RAID"] = "Commencez L'Incursion",
		["END_RAID"] = "Incursion De Fin",
		["SET_MAIN"] = "Le caractre courant est maintenant la force pour tous les autres pour ce joueur.",
		["HIDE_CHAR"] = "Caractre De Peau",
		["SHOW_CHAR"] = "Montrez Le Caractre",
	},
}
RDKP_SZ.enGB = RDKP_SZ.enUS;

function RDKP_DeployLocalizedStrings()
	-- Take the strings available in the localized table,
	-- And load them into the strings used by the UI.
	-- First use the english to populate as defaults.
	local szLang = GetLocale();
	RDKP_SZ_HEADER = RDKP_GetLocalizedString(szLang, "HEADER");
	RDKP_SZ_PATTERN_DEATH1 = RDKP_GetLocalizedString(szLang, "PATTERN_DEATH1");
	RDKP_SZ_PATTERN_DEATH2 = RDKP_GetLocalizedString(szLang, "PATTERN_DEATH2");
	RDKP_SZ_PATTERN_LOOT = RDKP_GetLocalizedString(szLang, "PATTERN_LOOT");
	RDKP_SZ_PATTERN_LOOT1 = RDKP_GetLocalizedString(szLang, "PATTERN_LOOT1");
	RDKP_SZ_PATTERN_LOOT2 = RDKP_GetLocalizedString(szLang, "PATTERN_LOOT2");
	RDKP_SZ_DATA_RESET = RDKP_GetLocalizedString(szLang, "DATA_RESET");
	RDKP_SZ_RESTORE_DEFAULTS = RDKP_GetLocalizedString(szLang, "RESTORE_DEFAULTS");
	RDKP_SZ_NO_KILL_AWARD = RDKP_GetLocalizedString(szLang, "NO_KILL_AWARD");
	RDKP_SZ_NO_TIME_AWARD = RDKP_GetLocalizedString(szLang, "NO_TIME_AWARD");
	RDKP_SZ_RAID_START = RDKP_GetLocalizedString(szLang, "RAID_START");
	RDKP_SZ_RAID_END = RDKP_GetLocalizedString(szLang, "RAID_END");
	RDKP_SZ_START_RAID =RDKP_GetLocalizedString(szLang, "START_RAID");
	RDKP_SZ_END_RAID = RDKP_GetLocalizedString(szLang, "END_RAID");
	RDKP_SZ_SET_MAIN = RDKP_GetLocalizedString(szLang, "SET_MAIN");
	RDKP_SZ_HIDE_CHAR = RDKP_GetLocalizedString(szLang, "HIDE_CHAR");
	RDKP_SZ_SHOW_CHAR = RDKP_GetLocalizedString(szLang, "SHOW_CHAR");
end

function RDKP_GetLocalizedString(szLang, szString)
	if (RDKP_SZ[szLang]) and (RDKP_SZ[szLang][szString]) then
		return RDKP_SZ[szLang][szString];
	else
		if (RDKP_SZ.enUS) and (RDKP_SZ["enUS"][szString]) then
			return RDKP_SZ["enUS"][szString];
		end
	end
	return "String [" .. szString ..  "] Not Available."
end
