-----------------------------------------
-- Addon: Relational DKP
-- By: Shazear 
-- Shizukana <Veterans of the Phoenix>, Malygos
-- e-mail: shazear@hotmail.com
-- Code also used from CTRT
-- References: 
-----------------------------------------

-----------------------------------------
-- Variables & Constants:
-----------------------------------------
-- Background Contants:
RDKP_FULL_VERSION = "2.1.2.1";
RDKP_INTERFACE_VERSION = {
--	["CURRENT"] = "TEST",
	["CURRENT"] = "04",
	["OLD_03"] = "03",
	["OLD_02"] = "02",
	["OLD_01"] = "01",
}
RDKP_SZ_ADDON_PREFIX = "RDKP" ..  RDKP_INTERFACE_VERSION.CURRENT;
RDKP_SZ_ADDON_PREFIX_OLD = "RDKP" .. RDKP_INTERFACE_VERSION["OLD_03"];
RDKP_SZ_ADDON_PREFIX_OLD_02 = "RDKP" .. RDKP_INTERFACE_VERSION["OLD_02"];
RDKP_SZ_ADDON_PREFIX_OLD_01 = "RDKP" .. RDKP_INTERFACE_VERSION["OLD_01"];
RDKP_SZ_RAIDKEY_PREFIX = "RKID!";
RDKP_SZ_FIELD_DELIMITER = "!";
RDKP_SZ_HAVERAID_PREFIX = "HAVE_RAID ";
RDKP_SZ_TRANSACTION_PREFIX = "TRANS ";
RDKP_SZ_REQUESTRAID_PREFIX = "REQ_RAID ";
RDKP_SZ_CHAR_TRANSMIT_PREFIX = "CHARS ";
RDKP_SZ_LASTUPDATE = "LastUpdated";
RDKP_SZ_MYCHARACTERS = "MyCharacters";
RDKP_SZ_MYMAINCHAR = "MyMainCharacter";
RDKP_SZ_DKPFORTIME = "RDKP_DKPForTime";
RDKP_SZ_MAINCHAR = "szMain";
RDKP_SZ_SETTINGSREQUEST = "REQ_SET";
RDKP_SZ_SETTINGSUPDATE_DKP = "UPD_SET1";
RDKP_SZ_SETTINGSUPDATE_GR = "UPD_SET2";
RDKP_SZ_HIDE = "HIDE";
RDKP_SZ_SHOW = "SHOW";
RDKP_PRIORITY_FRAME_HEIGHT = 15; 
RDKP_PRIORITY_BUTTON_QTY = 19;
RDKP_SZ_TABLE = "TABLE";
RDKP_SZ_HASH = "HASH";
RDKP_SZ_REALMNAME = GetRealmName();
RDKP_B_EventFloodBlock = false;  -- this is to prevent some double event handling.
RDKP_SZ_PATTERNDATE =  "(%d%d%d%d).(%d%d).(%d%d)";
RDKP_t_GuildRosterUpdateFloodBlock = 0;

-----------------------------------------
-- Data Constants:
-- These shouldn't change, only grow w/ WOW patches.
-- Table of the gear valuation by zone.  Rares, Epics, and Legendaries, and then by zone.  
RDKP_Table_Zones = {
	["Raid"] = {
		["WOW"] = {
			"Blackrock Spire",
			"Zul'Gurub",
			"Ruins of Ahn'Qiraj",
			"Molten Core",
			"Onyxia's Lair",
			"Temple of Ahn'Qiraj",
			"Blackwing Lair",
			"Naxxramas", 
		},
		["TBC"] = {
			"Karazhan",
			"Zul'Aman",
			"Battle of Mount Hyjal",
			"Magtheridon's Lair",
			"Serpentshrine Cavern",
			"The Eye",
			"Gruul's Lair",
			"Black Temple",
		},
	},
	["Party"] = {
		["WOW"] = {},
		["TBC"] = {
			"Hellfire Ramparts",
			"The Blood Furnace",
			"The Shattered Halls",
			"The Slave Pens",
			"The Underbog",
			"The Steamvault",
			"Mana-Tombs",
			"Auchenai Crypts",
			"Sethekk Halls",
			"Shadow Labyrinth",
			"The Mechanar",
			"The Botanica",
			"The Arcatraz",
			"Old Hillsbrad Foothills",
			"Black Morass",
		},
	},
}

RDKP_MAP_STRINGS = {
	["ZONES"] = {
	 	["Blackrock Spire"] = "BRS",
		["Onyxia's Lair"] = "OL", 
		["Zul'Gurub"] = "ZG",
		["Molten Core"] = "MC",
		["Blackwing Lair"] = "BWL",
		["Ruins of Ahn'Qiraj"] = "AQ20",
		["Temple of Ahn'Qiraj"] = "AQ40",
		["Naxxramas"] = "NAX",
		-- TBC instances:
		-- TODO: High: Verify Name/spelling/GetRealZoneText() returns
		["Hellfire Ramparts"] = "HR",
		["The Blood Furnace"] = "TBF",
		["Coilfang Reservoir"] = "CR",
		["Auchindoun"] = "AUC",
		["Tempest Keep"] = "TK",
		["Karazhan"] = "KZ",
		["Black Temple"] = "BT",
		["Zul'Aman"] = "ZA",
		["Battle of Mount Hyjal"] = "BMH",
		["Magtheridon's Lair"] = "MAG",
		["Serpentshrine Cavern"] = "SC",
		["The Eye"] = "EYE",
		["Gruul's Lair"] = "GL",
		
		["BRS"] = "Blackrock Spire",
		["OL"] = "Onyxia's Lair" , 
		["ZG"] = "Zul'Gurub",
		["MC"] = "Molten Core",
		["BWL"] = "Blackwing Lair" ,
		["AQ20"] = "Ruins of Ahn'Qiraj",
		["AQ40"] = "Temple of Ahn'Qiraj",
		["NAX"] = "Naxxramas" ,
		-- TBC:
		["HR"] = "Hellfire Ramparts",
		["TBF"] = "The Blood Furnace",
		["CR"] = "Coilfang Reservoir" ,
		["AUC"] = "Auchindoun",
		["TK"] = "Tempest Keep" ,
		["KZ"] = "Karazhan",
		["BT"] = "Black Temple",
		["ZA"] = "Zul'Aman",
		["BMH"] = "Battle of Mount Hyjal",
		["MAG"] = "Magtheridon's Lair",
		["SC"] = "Serpentshrine Cavern",
		["EYE"] = "The Eye",
		["GL"] = "Gruul's Lair",
	},
	["RARITY"] = {
		["ff9d9d9d"] = -1,
		["ffffffff"] = 0,
		["ff1eff00"] = 1,
		["ff0070dd"] = 2,
		["ffa335ee"] = 3,
		["ffff8000"] = 4
	},
	["RARITY_INT"] = {
		[-1] = "ff9d9d9d",
		[0] = "ffffffff",
		[1] = "ff1eff00",
		[2] = "ff0070dd",
		[3] = "ffa335ee",
		[4] = "ffff8000",
	},
}

RDKP_TableForAudit = {
	["PlayerName"] = nil,
	["DKP"] = 0,
	["GR"] = 0
}

RDKP_Table_PlayersSorted = {
}

-- Table of players to track.  This table will be pulled from the guildlist.
RDKP_Table_MasterPlayers = {
}

-- Log of all Raid Transactions
RDKP_Table_Raid_Register = {
}

-- Log of Toons associated w/ this account.
RDKP_Table_CharacterMap = {
	[RDKP_SZ_MYCHARACTERS] = nil,
}

RDKP_Table_RaidInfo = {
	["RDKP_RaidID"] = nil,
	["RDKP_TransactionID"] = 0,
	["RDKP_bCurrentRaid"] = nil,
	["RecordRaid"] = 0,
}

RDKP_FilterBy = {
	["HideAlts"] = nil; -- This is for filtering out the alts out of the player list so we only see the mains.
	["ShowHidden"] = nil; -- This is for showing those we have selected shouldn't be seen anymore. (left guild, or whatever)
	["RaidMembers"] = nil;
	["PST"] = nil;
	["SortBy"] = "PRI";
	["ShowDestroyedRaids"] = nil;
}

RDKP_DebugLog = {}

-- Table for storing a list of which characters are selected.
RDKP_PlayerSelectList = {}

-- Temporary Holding table for received table data.
RDKP_Table_Temp = {}

-- Holding table for loot - if someone DE's assume they've de'd the last thing of value they've received.
RDKP_Last_Loot = {}

RDKP_AwardPlugins = {}

RDKP_Settings = {
	["InitialPlayerData"] = {
		["DKP"] = 0;
		["GR"] = 25;
	},
	["date"] = nil,
	["OnlyOfficersCanRunRaids"] = 0,
	["AllowDKPFor5ManRuns"] = 0,
	["AllowDKPForOldWowInstances"] = 1,
	["EarnDKPWhenOffline"] = 1,
	["EarnDKPWhenNotInZone"] = 0,
	["EarnDKPWhenAFK"] = 0,
	["PrioritySystem"] = "RATIO",
	["ResetEditFields"] = 1, 
	["PurgeBeforeDate"] = nil,
	["DKP"] = {
		["TIME"] = 1, -- In DKP per Hour.
		-- UBRS Only:
		["Blackrock Spire"] = {
			["Pyroguard Emberseer"] = 0,
			["Solakar Flamewreath"] = 0,
			["Jed Runewatcher"] = 0,
			["Goraluk Anvilcrack"] = 0,
			["Gyth"] = 0,
			["Rend Blackhand"] = 0,
			["The Beast"] = 0,
			["Lord Valthalak"] = 0,
			["General Drakkisath"] = 0, 
		},
		-- ZG:
		["Zul'Gurub"] = {
			["High Priestess Jeklik"] = 5,
			["High Priest Venoxis"] = 5,
			["High Priestess Mar'li"] = 5,
			["High Priest Thekal"] = 5,
			["High Priestess Arlokk"] = 5,
			["Hakkar the Soulflayer"] = 5,
			["Bloodlord Mandokir"] = 5,
			["Jin'do the Hexxer"] = 5,
			["Gahz'ranka"] = 5,
			["Gri'lek"] = 5,
			["Renataki"] = 5,
			["Hazza'rah"] = 5,
			["Wushoolay"] = 5,
		},
		-- AQ 20:
		["Ruins of Ahn'Qiraj"] = {
			["Kurinnaxx"] = 5,
			["General Rajaxx"] = 5,
			["Moam"] = 5,
			["Buru the Gorger"] = 5,
			["Ayamiss the Hunter"] = 5,
			["Ossirian the Unscarred"] = 5,
		},
		-- MC:
		["Molten Core"] = {
			["Lucifron"] = 5,
			["Magmadar"] = 5,
			["Gehennas"] = 5,
			["Garr"] = 5,
			["Baron Geddon"] = 5,
			["Shazzrah"] = 5,
			["Golemagg The Incinerator"] = 5,
			["Golemagg the Incinerator"] = 5,
			["Sulfuron Harbinger"] = 5,
			["Majordomo Executus"] = 5,
			["Ragnaros"] = 5,
		},
		-- Ony:
		["Onyxia's Lair"] = {
			["Onyxia"] = 5,
		},
		-- BWL:
		["Blackwing Lair"] = {
			["Razorgore the Untamed"] = 5,
			["Vaelastrasz the Corrupt"] = 5,
			["Broodlord Lashlayer"] = 5,
			["Firemaw"] = 5,
			["Ebonroc"] = 5,
			["Flamegor"] = 5,
			["Chromaggus"] = 5,
			["Nefarian"] = 5,
		},
		-- AQ40:
		["Temple of Ahn'Qiraj"] = {
			["The Prophet Skeram"] = 5,
			["Vem"] = 5,
			["Yauj"] = 5,
			["Kri"] = 5,
			["Battleguard Sartura"] = 5,
			["Fankriss the Unyielding"] = 5,
			["Viscidus"] = 5,
			["Princess Huhuran"] = 5,
			["Emperor Vek'lor"] = 5,
			["Emperor Vek'nilash"] = 5,
			["Ouro the Sandworm"] = 5,
			["C'Thun"] = 5,
		},
		-- Naxx:
		["Naxxramas"] = {
			["Anub'Rekhan"] = 5,
			["Grand Widow Faerlina"] = 5,
			["Maexxna"] = 5,
			["Patchwerk"] = 5,
			["Grobbulus"] = 5,
			["Gluth"] = 5,
			["Thaddius"] = 5,
			["Feugen"] = 5,
			["Stalagg"] = 5,
			["Noth The Plaguebringer"] = 5,
			["Heigan the Unclean"] = 5,
			["Loatheb"] = 5,
			["Instructor Razuvious"] = 5,
			["Gothik the Harvester"] = 5,
			["Highlord Mograine"] = 5,
			["Thane Korthazz"] = 5,
			["Lady Blaumeux"] = 5,
			["Sir Zeliek"] = 5,
			["Sapphiron"] = 5,
			["Kel'Thuzad"] = 5,
		},
		-- Below Data pulled from WOWWIKI: 
		["Karazhan"] = {
			["Attumen the Huntsman"] = 5,
			["Midnight"] = 5,
			["Moroes"] = 5,
			["Maiden of Virtue"] = 5,
			["The Curator"] = 5,
			["Terestian Illhoof"] = 5,
			["Shade of Aran"] = 5,
			["Netherspite"] = 5,
			["Nightbane"] = 5,
			["Prince Malchezaar"] = 5,
			["Hyakiss the Lurker"] = 5,
			["Rokad the Ravager"] = 5,
			["Shadikith the Glider"] = 5,
			["Dorothee"] = 5,
			["Tito"] = 5,
			["Roar"] = 5,
			["Strawman"] = 5,
			["Tinhead"] = 5,
			["The Crone"] = 5,
			["The Big Bad Wolf"] = 5,
			["Romulo"] = 5,
			["Julianne"] = 5,
		},
		["Zul'Aman"] = {
			["Nalorakk"] = 5,
			["Akil'Zon"] = 5,
			["Jan'Alai"] = 5,
			["Halazzi"] = 5,
			["Hex Lord Malacrass"] = 5,
			["Zul'jin"] = 5,
		},
		["Battle for Mount Hyjal"] = {
			["Rage Winterchill"] = 5,
			["Anetheron"] = 5,
			["Kaz'rogal"] = 5,
			["Azgalor"] = 5,
			["Archimonde"] = 5,
		},
		["Magtheridon's Lair"] = {
			["Magtheridon"] = 5,
		},
		["Serpentshrine Cavern"] = {
			["Hydross the Unstable"] = 5,
			["Fathom-Lord Karathress"] = 5,
			["Morogrim Tidewalker"] = 5,
			["Leotheras the Blind"] = 5,
			["Lady Vashj"] = 5,
		},
		["The Eye"] = {
			["Prince Kael'thas Sunstrider"] = 5,
		},
		["Gruul's Lair"] = {
			["High King Maulgar"] = 5,
			["Gruul"] = 5,
		},
		["Black Temple"] = {
			["Illidan Stormrage"] = 5,
		},
		-- 5 man instances:
		["Hellfire Ramparts"] = {
			["Watchkeeper Gargolmar"] = 5,
			["Omor the Unscarred"] = 5,
			["Nazan"] = 5,
		},
		["The Blood Furnace"] = {
			["The Maker"] = 5,
			["Broggok"] = 5,
			["Keli'dan the Breaker"] = 5,
		},
		["The Shattered Halls"] = {
			["Grand Warlock Nethekurse"] = 5,
			["Warbringer O'mrogg"] = 5,
			["Kargath Bladefist"] = 5,
		},
		["The Slave Pens"] = {
			["Mennu the Betrayer"] = 5,
			["Rokmar the Crackler"] = 5,
			["Quagmirran"] = 5,
		},
		["The Underbog"] = {
			["Hungarfen"] = 5,
			["Ghaz'an"] = 5,
			["Swamplord Musel'ek"] = 5,
			["The Black Stalker"] = 5,
		},
		["The Steamvault"] = {
			["Hydromancer Thespia"] = 5,
			["Mekgineer Steamrigger"] = 5,
			["Warlord Kalithresh"] = 5,
		},
		["Mana-Tombs"] = {
			["Pandemonius"] = 5,
			["Tavarok"] = 5,
			["Nexus-Prince Shaffar"] = 5,
		},
		["Auchenai Crypts"] = {
			["Shirrak the Dead Watcher"] = 5,
			["Exarch Maladaar"] = 5,
		},
		["Sethekk Halls"] = {
			["Darkweaver Syth"] = 5,
			["Talon King Ikiss"] = 5,
		},
		["Shadow Labyrinth"] = {
			["Ambassador Hellmaw"] = 5,
			["Blackheart the Inciter"] = 5,
			["Grandmaster Vorpil"] = 5,
			["Murmur"] = 5,
		},
		["The Mechanar"] = {
			["Gatewatcher Gyro-Kill"] = 5,
			["Gatewatcher Iron-Hand"] = 5,
			["Mechano-Lord Capacitus"] = 5,
			["Nethermancer Sepethrea"] = 5,
			["Pathaleon the Calculator"] = 5,
		},
		["The Botanica"] = {
			["Commander Sarannis"] = 5,
			["High Botanist Greywinn"] = 5,
			["Thorngrin the Tender"] = 5,
			["Laj"] = 5,
			["Warp Splinter"] = 5,
		},
		["The Arcatraz"] = {
			["Zereketh the Unbound"] = 5,
			["Wrath-Scryer Soccothrates"] = 5,
			["Dalliah the Doomsayer"] = 5,
			["Warden Mellichar"] = 5,
		},
		["Old Hillsbrad Foothills"] = {
			["Lieutenant Drake"] = 5,
			["Captain Skarloc"] = 5,
			["The Epoch Hunter"] = 5,
		},
		["Black Morass"] = {
			["Chrono Lord Deja"] = 5,
			["Temporus"] = 5,
			["Aeonus"] = 5,
		},
	},
	["GR"] = {
		-- [quality] = { [location] = GRValue }
		[1] = { -- Greens  Adding this for other people though don't think I have the room in the UI for this yet. :)
			["Blackrock Spire"] = 0,
			["Zul'Gurub"] = 0,
			["Ruins of Ahn'Qiraj"] = 0,
			["Molten Core"] = 0,
			["Onyxia's Lair"] = 0,
			["Temple of Ahn'Qiraj"] = 0,
			["Blackwing Lair"] = 0,
			["Naxxramas"] = 0,
			["Karazhan"] = 0,
			["Zul'Aman"] = 0,
			["Battle of Mount Hyjal"] = 0,
			["Magtheridon's Lair"] = 0,
			["Serpentshrine Cavern"] = 0,
			["The Eye"] = 0,
			["Gruul's Lair"] = 0,
			["Black Temple"] = 0,
			-- 5 Man TBC:
			["Hellfire Ramparts"] = 0,
			["The Blood Furnace"] = 0,
			["The Shattered Halls"] = 0,
			["The Slave Pens"] = 0,
			["The Underbog"] = 0,
			["The Steamvault"] = 0,
			["Mana-Tombs"] = 0,
			["Auchenai Crypts"] = 0,
			["Sethekk Halls"] = 0,
			["Shadow Labyrinth"] = 0,
			["The Mechanar"] = 0,
			["The Botanica"] = 0,
			["The Arcatraz"] = 0,
			["Old Hillsbrad Foothills"] = 0,
			["Black Morass"] = 0,
		},
		[2] = { -- Rare
			["Blackrock Spire"] = 0,
			--    * Blue items from ZG/AQ20: 15 DKP points
			["Zul'Gurub"] = 15,
			["Ruins of Ahn'Qiraj"] = 15,
			--    * Blue items from MC+: 25 DKP points
			["Molten Core"] = 25,
			["Onyxia's Lair"] = 25,
			["Temple of Ahn'Qiraj"] = 25,
			["Blackwing Lair"] = 25,
			["Naxxramas"] = 25,
			["Karazhan"] = 30,
			["Zul'Aman"] = 30,
			["Battle of Mount Hyjal"] = 30,
			["Magtheridon's Lair"] = 30,
			["Serpentshrine Cavern"] = 30,
			["The Eye"] = 30,
			["Gruul's Lair"] = 30,
			["Black Temple"] = 30,
			-- 5 Man TBC:
			["Hellfire Ramparts"] = 0,
			["The Blood Furnace"] = 0,
			["The Shattered Halls"] = 0,
			["The Slave Pens"] = 0,
			["The Underbog"] = 0,
			["The Steamvault"] = 0,
			["Mana-Tombs"] = 0,
			["Auchenai Crypts"] = 0,
			["Sethekk Halls"] = 0,
			["Shadow Labyrinth"] = 0,
			["The Mechanar"] = 0,
			["The Botanica"] = 0,
			["The Arcatraz"] = 0,
			["Old Hillsbrad Foothills"] = 0,
			["Black Morass"] = 0,
		},
		[3] = { -- Epic
			["Blackrock Spire"] = 0,
			--    * Epic items from ZG/AQ20: 20 DKP points
			["Zul'Gurub"] = 20,
			["Ruins of Ahn'Qiraj"] = 20,
			--    * Epic items from MC: 30 DKP points
			["Molten Core"] = 30,
			["Onyxia's Lair"] = 30,
			--    * Epic items from AQ40: 35 DKP points
			["Temple of Ahn'Qiraj"] = 35,
			--    * Epic items from BWL: 40 DKP points
			["Blackwing Lair"] = 40,
			-- Below value used to fill.
			["Naxxramas"] = 45,
			["Karazhan"] = 50,
			["Zul'Aman"] = 50,
			["Battle of Mount Hyjal"] = 50,
			["Magtheridon's Lair"] = 50,
			["Serpentshrine Cavern"] = 50,
			["The Eye"] = 50,
			["Gruul's Lair"] = 50,
			["Black Temple"] = 50,
			-- 5 Man TBC:
			["Hellfire Ramparts"] = 0,
			["The Blood Furnace"] = 0,
			["The Shattered Halls"] = 0,
			["The Slave Pens"] = 0,
			["The Underbog"] = 0,
			["The Steamvault"] = 0,
			["Mana-Tombs"] = 0,
			["Auchenai Crypts"] = 0,
			["Sethekk Halls"] = 0,
			["Shadow Labyrinth"] = 0,
			["The Mechanar"] = 0,
			["The Botanica"] = 0,
			["The Arcatraz"] = 0,
			["Old Hillsbrad Foothills"] = 0,
			["Black Morass"] = 0,
		},
		[4] = { -- Legendary
			-- No Rules for this.
			["Blackrock Spire"] = 0,
			["Zul'Gurub"] = 0,
			["Ruins of Ahn'Qiraj"] = 0,
			["Molten Core"] = 0,
			["Onyxia's Lair"] = 0,
			["Temple of Ahn'Qiraj"] = 0,
			["Blackwing Lair"] = 0,
			["Naxxramas"] = 0,
			["Karazhan"] = 0,
			["Zul'Aman"] = 0,
			["Battle of Mount Hyjal"] = 0,
			["Magtheridon's Lair"] = 0,
			["Serpentshrine Cavern"] = 0,
			["The Eye"] = 0,
			["Gruul's Lair"] = 0,
			["Black Temple"] = 0,
			-- 5 Man TBC:
			["Hellfire Ramparts"] = 0,
			["The Blood Furnace"] = 0,
			["The Shattered Halls"] = 0,
			["The Slave Pens"] = 0,
			["The Underbog"] = 0,
			["The Steamvault"] = 0,
			["Mana-Tombs"] = 0,
			["Auchenai Crypts"] = 0,
			["Sethekk Halls"] = 0,
			["Shadow Labyrinth"] = 0,
			["The Mechanar"] = 0,
			["The Botanica"] = 0,
			["The Arcatraz"] = 0,
			["Old Hillsbrad Foothills"] = 0,
			["Black Morass"] = 0,
		},
	},
	-- TODO: Add these to the settings UI.
	["LOOT_NOCHARGE"] = {
		"Bone Scarab",
		"Bronze Scarab",
		"Clay Scarab",
		"Crystal Scarab",
		"Gold Scarab",
		"Ivory Scarab",
		"Silver Scarab",
		"Stone Scarab",
		"Bloodscalp Coin",
		"Gurubashi Coin",
		"Hakkari Coin",
		"Razzashi Coin",
		"Sandfury Coin",
		"Skullsplitter Coin",
		"Vilebranch Coin",
		"Witherbark Coin",
		"Zulian Coin",
		"Red Hakkari Bijou",
		"Purple Hakkari Bijou",
		"Orange Hakkari Bijou",
		"Gold Hakkari Bijou",
		"Yellow Hakkari Bijou",
		"Silver Hakkari Bijou",
		"Green Hakkari Bijou",
		"Bronze Hakkari Bijou",
		"Blue Hakkari Bijou",
		"Lambent Idol",
		"Vermillion Idol",
		"Alabaster Idol",
		"Jasper Idol",
		"Azure Idol",
		"Onyx Idol",
		"Obsidian Idol",
		"Amber Idol",
		"Fiery Core",
		"Lava Core"
	},
	-- TODO: Add these to the settings UI.
	["DE_MATS"] = {
		"Nexus Crystal",
		"Small Glimmering Shard",
		"Large Glimmering Shard",
		"Small Radiant Shard",
		"Small Glowing Shard",
		"Large Glowing Shard",
		"Small Radiant Shard",
		"Large Radiant Shard",
		"Small Brilliant Shard",
		"Large Brilliant Shard",
		"Greater Astral Essence",
		"Greater Eternal Essence",
		"Greater Magic Essence",
		"Greater Mystic Essence",
		"Greater Nether Essence",
		"Lesser Astral Essence",
		"Lesser Eternal Essence",
		"Lesser Magic Essence",
		"Lesser Mystic Essence",
		"Lesser Nether Essence",
		"Dream Dust",
		"Illusion Dust",
		"Soul Dust",
		"Strange Dust",
		"Vision Dust",
		-- Below this are TBC Disenchanting creates:
		"Arcane Dust",
		"Greater Astral Essence",
		"Lesser Astral Essence",
		"Greater Nether Essence",
		"Lesser Nether Essence",
		"Greater Planar Essence",
		"Lesser Planar Essence",
	},
}
-- End Variables
-----------------------------------------
